package catshelter;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.ICoolBarManager;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.ToolBarContributionItem;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.application.ActionBarAdvisor;
import org.eclipse.ui.application.IActionBarConfigurer;
import org.eclipse.ui.plugin.AbstractUIPlugin;

public class CatActionBarAdvisor extends ActionBarAdvisor {

	private Action demoAction;
	
	public CatActionBarAdvisor(IActionBarConfigurer configurer) {
		super(configurer);
	}
	
	@Override
	protected void fillMenuBar(IMenuManager menuBar) {
		MenuManager windowMenu = new MenuManager("winDow", IWorkbenchActionConstants.M_WINDOW);
		windowMenu.add(demoAction);
		menuBar.add(windowMenu);
	}
	
	@Override
	protected void makeActions(final IWorkbenchWindow window) {
		ImageDescriptor demoActionIcon = AbstractUIPlugin
				.imageDescriptorFromPlugin("org.eclipse.rap.ui",
						"icons/full/obj16/font.gif");
		
		demoAction = new Action() {
			@Override
			public void run() {
				MessageDialog.openInformation(window.getShell(), "Popup", "A simple message dialog");
			}
		};
		
		demoAction.setText("Pop me up");
		demoAction.setId("catshelter.popup");
		demoAction.setImageDescriptor(demoActionIcon);
	}
	
	@Override
	protected void fillCoolBar(ICoolBarManager coolBar) {
		IToolBarManager toolBar = new ToolBarManager();
		toolBar.add(demoAction);
		coolBar.add(new ToolBarContributionItem(toolBar, "toolbar.item1.demoAction"));
	}
}
