package catshelter;

import java.util.List;

import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredViewer;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.ViewPart;

import catshelter.editor.CatEditor;
import catshelter.editor.CatEditorInput;
import catshelter.model.Cat;
import catshelter.provider.CatLabelProvider;
import catshelter.provider.CatsProvider;

public class CatShelterView extends ViewPart {

	public static final String ID = "catshelter.view";
	private TableViewer viewer;
	
	public CatShelterView() {

	}
	
	public TableViewer getViewer() {
		return viewer;
	}

	@Override
	public void createPartControl(Composite parent) {
		parent.setLayout(new FillLayout(SWT.VERTICAL));
		
		Label helloWorld = new Label(parent, SWT.HORIZONTAL);
		helloWorld.setText("Those cats need new can opener");
		
		viewer = new TableViewer(parent);
		CatLabelProvider labels = new CatLabelProvider();
		labels.createColumns(viewer);
		viewer.setLabelProvider(labels);
		viewer.setContentProvider(new CatsProvider());
		
		viewer.setInput(getSite());
		
		getSite().setSelectionProvider(viewer);
		addEditor(viewer);
	}
	
	private void addEditor(StructuredViewer viewer) {
		viewer.addDoubleClickListener(new IDoubleClickListener() {
			@Override
			public void doubleClick(DoubleClickEvent event) {
				ISelection selection = getViewer().getSelection();
				if (selection instanceof IStructuredSelection) {
					List selectionList = ((IStructuredSelection) selection).toList();
					for (Object selectedObject : selectionList) {
						if (selectedObject instanceof Cat) {
							CatEditorInput input = new CatEditorInput((Cat) selectedObject);
							try {
								getSite().getPage().openEditor(input, CatEditor.ID);
							} catch (PartInitException e) {
								throw new RuntimeException(CatEditor.ID + " not found");
							}
						}
					}
				}
			}
		});
	}

	@Override
	public void setFocus() {
	
	}

}
