package catshelter.editor;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

import catshelter.model.Cat;

public class CatEditorInput implements IEditorInput {

	public static final String ID = "catshelter.editorInput";
	private final Cat cat;
	
	public CatEditorInput(Cat cat) {
		this.cat = cat;
	}
	
	@Override
	public String getName() {
		return cat.getName();
	}
	
	@Override
	public String getToolTipText() {
		return cat.getName() + " likes " + cat.getLikes();
	}
	
	@Override
	public Object getAdapter(Class adapter) {
		return cat;
	}

	@Override
	public boolean exists() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public ImageDescriptor getImageDescriptor() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IPersistableElement getPersistable() {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((cat == null) ? 0 : cat.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CatEditorInput other = (CatEditorInput) obj;
		if (cat == null) {
			if (other.cat != null)
				return false;
		} else if (!cat.equals(other.cat))
			return false;
		return true;
	}
	
}
