package catshelter.provider;

import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;

import catshelter.model.Cat;

public class CatLabelProvider extends LabelProvider implements ITableLabelProvider {

	private static final String[] titles = { "Name", "Likes", "Gender" };
	
	@Override
	public Image getColumnImage(Object element, int columnIndex) {
		return null;
	}
	
	@Override
	public String getColumnText(Object element, int columnIndex) {
		Cat cat = (Cat) element;
		switch(columnIndex) {
			case 0 : return cat.getName();
			case 1 : return cat.getLikes();
			case 2 : return cat.getGender().toString();
			default : return null;
		}
	}
	
	public void createColumns(TableViewer viewer) {
		for (String title : titles) {
			TableViewerColumn column = new TableViewerColumn(viewer, SWT.NONE);
			column.getColumn().setWidth(100);
			column.getColumn().setText(title);
			column.getColumn().setResizable(true);
		}
		
		Table table = viewer.getTable();
		table.setHeaderVisible(true);
		table.setLinesVisible(true);
	}
	
}
